com.ihr.xbrl.versioning

## Class VlVersioningProcessor

- java.lang.Object
- - com.ihr.xbrl.versioning.VlVersioningProcessor

-     public class VlVersioningProcessor
      extends java.lang.Object

  This is the versioning processor instance.

  A VersionigProcessor can load the content of a versioning report in XBRL format. Provides methods to access to the report content and allows editing the report.

  The processor allows the creation of XBRL Versioning Reports by comparing two DTSContainer objects.

  Author:
    Ignacio

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `VlVersioningProcessor.ClsVersioningNamespace` The Class ClsVersioningNamespace.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static javax.xml.namespace.QName` | `versionLinkbaseLink` The Constant versionLinkbaseLink.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `VlVersioningProcessor(java.lang.String versioningDTSUri, java.lang.String versioningConfSuiteSchema)` Creates an instance of the versioning processor.
    `VlVersioningProcessor(java.lang.String versioningDTSUri, java.lang.String versioningConfSuiteSchema, DTSContainer fromDTS, DTSContainer toDTS)` Creates an instance of the versioning processor.
    `VlVersioningProcessor(java.lang.String versioningDTSUri, java.lang.String versioningConfSuiteSchema, XBRLInstance vlDTS)` Creates an instance of the versioning processor.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addAction(Action ac)` Adds the action.
    `void` | `addAssignment(Assignment as)` Adds the assignment.
    `void` | `compare()` Launch the comparison of the fromDTS and the toDTS.
    `java.util.Collection<Action>` | `getActions()` Gets the actions.
    `java.util.Collection<Assignment>` | `getAssignments()` Gets the assignments.
    `DTSComparator` | `getComparator()` Gets the comparator.
    `java.lang.String` | `getVersioningDTSUri()` Gets the versioning dts uri.
    `boolean` | `isAssignmentsUpdated()` Checks if is assignments updated.
    `boolean` | `isDocumented(Event ev)` Returns true if the event is in at least one action in this report.
    `void` | `loadLaunchFile(java.net.URI temporaryFileURI)` Load a launch file.
    `void` | `loadVersioningReport(XBRLInstance versioningReport)` Second edition of this method.
    `void` | `removeAction(Action action)` Removes the action.
    `void` | `removeAssignment(Assignment assignment)` Removes the assignment.
    `void` | `reset()` Reset.
    `void` | `resetAssignmentsUpdated()` Reset assignments updated.
    `void` | `saveLaunchFile(java.net.URI fNameUri)` Write the content of the versioning report in a launch file This is a temporary method. the Raw XML launch file will be used only in the conformance suite
    `void` | `setEmail(java.lang.String text)` Sets the email.
    `void` | `setOwner(java.lang.String text)` Sets the owner.
    `void` | `setResult(java.net.URI resultFile)` Sets the result.
    `void` | `setVersioningTestCaseXSLTUri(java.lang.String text)` Sets the versioning test case xslt uri.
    `ConceptActivityReport` | `whatHappendedTo(javax.xml.namespace.QName conceptFrom)` What happended to.

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### versionLinkbaseLink

          public static final javax.xml.namespace.QName versionLinkbaseLink

      The Constant versionLinkbaseLink.

  - ### Constructor Detail

    - #### VlVersioningProcessor

          public VlVersioningProcessor(java.lang.String versioningDTSUri,
                               java.lang.String versioningConfSuiteSchema)
                                throws com.rs.lic.LicenseVerificationException

      Creates an instance of the versioning processor.
      Parameters:
        `versioningDTSUri` - String relative uri to the versioning schema
        `versioningConfSuiteSchema` - String relative uri to the conformance suite schema
      Throws:
        `com.rs.lic.LicenseVerificationException` - the license verification exception

    - #### VlVersioningProcessor

          public VlVersioningProcessor(java.lang.String versioningDTSUri,
                               java.lang.String versioningConfSuiteSchema,
                               DTSContainer fromDTS,
                               DTSContainer toDTS)
                                throws DTSDiscoveryException,
                                       com.rs.lic.LicenseVerificationException

      Creates an instance of the versioning processor.
      Parameters:
        `versioningDTSUri` - String relative uri to the versioning schema
        `versioningConfSuiteSchema` - String relative uri to the conformance suite schema
        `fromDTS` - DTSContainer the initial from DTS
        `toDTS` - DTSContainer the initial to DTS
      Throws:
        `DTSDiscoveryException` - the DTS discovery exception
        `com.rs.lic.LicenseVerificationException` - the license verification exception

    - #### VlVersioningProcessor

          public VlVersioningProcessor(java.lang.String versioningDTSUri,
                               java.lang.String versioningConfSuiteSchema,
                               XBRLInstance vlDTS)
                                throws DTSDiscoveryException,
                                       com.rs.lic.LicenseVerificationException

      Creates an instance of the versioning processor.
      Parameters:
        `versioningDTSUri` - String relative uri to the versioning schema
        `versioningConfSuiteSchema` - String relative uri to the conformance suite schema
        `vlDTS` - instance document according to the versioning taxonomy schema to load
      Throws:
        `DTSDiscoveryException` - the DTS discovery exception
        `com.rs.lic.LicenseVerificationException` - the license verification exception

  - ### Method Detail

    - #### setOwner

          public void setOwner(java.lang.String text)

      Sets the owner.
      Parameters:
        `text` - the new owner

    - #### setResult

          public void setResult(java.net.URI resultFile)

      Sets the result.
      Parameters:
        `resultFile` - the new result

    - #### setEmail

          public void setEmail(java.lang.String text)

      Sets the email.
      Parameters:
        `text` - the new email

    - #### setVersioningTestCaseXSLTUri

          public void setVersioningTestCaseXSLTUri(java.lang.String text)

      Sets the versioning test case xslt uri.
      Parameters:
        `text` - the new versioning test case xslt uri

    - #### loadVersioningReport

          public void loadVersioningReport(XBRLInstance versioningReport)
                                    throws DTSDiscoveryException,
                                           com.rs.lic.LicenseVerificationException

      Second edition of this method. This loads an instande document that is a versioning report. The instance is not validated against the XBRL 2.1 specification.
      Parameters:
        `versioningReport` - XBRLInstance
      Throws:
        `DTSDiscoveryException` - the DTS discovery exception
        `com.rs.lic.LicenseVerificationException` - Occurs if the user does not have a license for any of the files in the DTS of the versioning report

    - #### saveLaunchFile

          public void saveLaunchFile(java.net.URI fNameUri)
                              throws XBRLSerializationException

      Write the content of the versioning report in a launch file This is a temporary method. the Raw XML launch file will be used only in the conformance suite
      Parameters:
        `fNameUri` - URI
      Throws:
        `XBRLSerializationException` - the XBRL serialization exception

    - #### getVersioningDTSUri

          public java.lang.String getVersioningDTSUri()

      Gets the versioning dts uri.
      Returns:
        String

    - #### loadLaunchFile

          public void loadLaunchFile(java.net.URI temporaryFileURI)
                              throws DTSDiscoveryException

      Load a launch file.
      Parameters:
        `temporaryFileURI` - the temporary file uri
      Throws:
        `DTSDiscoveryException` - the DTS discovery exception

    - #### reset

          public void reset()

      Reset.

    - #### compare

          public void compare()

      Launch the comparison of the fromDTS and the toDTS.

    - #### getComparator

          public DTSComparator getComparator()

      Gets the comparator.
      Returns:
        the comparator

    - #### getActions

          public java.util.Collection<Action> getActions()

      Gets the actions.
      Returns:
        the actions

    - #### getAssignments

          public java.util.Collection<Assignment> getAssignments()

      Gets the assignments.
      Returns:
        the assignments

    - #### addAssignment

          public void addAssignment(Assignment as)

      Adds the assignment.
      Parameters:
        `as` - the as

    - #### addAction

          public void addAction(Action ac)

      Adds the action.
      Parameters:
        `ac` - the ac

    - #### removeAssignment

          public void removeAssignment(Assignment assignment)

      Removes the assignment.
      Parameters:
        `assignment` - the assignment

    - #### removeAction

          public void removeAction(Action action)

      Removes the action.
      Parameters:
        `action` - the action

    - #### isAssignmentsUpdated

          public boolean isAssignmentsUpdated()

      Checks if is assignments updated.
      Returns:
        true, if is assignments updated

    - #### resetAssignmentsUpdated

          public void resetAssignmentsUpdated()

      Reset assignments updated.

    - #### isDocumented

          public boolean isDocumented(Event ev)

      Returns true if the event is in at least one action in this report.
      Parameters:
        `ev` - the ev
      Returns:
        boolean

    - #### whatHappendedTo

          public ConceptActivityReport whatHappendedTo(javax.xml.namespace.QName conceptFrom)

      What happended to.
      Parameters:
        `conceptFrom` - QName
      Returns:
        ConceptActivityReport